<?php

////////////////////////////////////////////////
////// EMPTY SCRIPTS CACHE /////////////////////
////////////////////////////////////////////////

function lcso_empty_scripts_cache() {
	if(!isset($_POST['lcso_nonce']) || !wp_verify_nonce($_POST['lcso_nonce'], 'lcso_ajax')) {
        wp_die('Cheating?');
    }
	
	require_once(LCSO_DIR .'/classes/engine.php');
	$engine = new lcso_engine('js', array(), '');
	
	// check folder existence
	if(!$engine->cache_folder_check()) {
		wp_die( __("Can't create cache folder", 'lcso_ml') );
	}
    elseif(!$engine->files_write_permissions_check()) {
		wp_die( __('No server permissions to manage files', 'lcso_ml') );	
	}
	

	// delete files
	$files = (array)@glob($engine->basedir .'/'. $engine->cache_folder .'/*');

	foreach($files as $file) { 
		if(is_file($file)) {
			@unlink($file);
		}
	}
	
    
    delete_option('lcso_cache_times');
	wp_die('success');
}
add_action('wp_ajax_lcso_empty_scripts_cache', 'lcso_empty_scripts_cache');







////////////////////////////////////////////////
////// STORE QUEUED SCRIPTS/STYLES /////////////
////////////////////////////////////////////////

function lcso_store_queued_scripts() {
	if(!isset($_POST['lcso_nonce']) || !wp_verify_nonce($_POST['lcso_nonce'], 'lcso_ajax')) {
        wp_die('Cheating?');
    }
	
	$args = array(
		'timeout'     => 3,
		'redirection' => 1,
	); 
	$response = wp_remote_get( get_home_url() .'?lcso_store_scripts', $args);
	
	if(is_wp_error($response) || wp_remote_retrieve_response_code($response) != 200) {
		wp_die( __('Error calling homepage', 'lcso_ml') );
	}
	else {
		wp_die('success');
	}
}
add_action('wp_ajax_lcso_store_queued_scripts', 'lcso_store_queued_scripts');







////////////////////////////////////////////////
////// DELETE STORED SCRIPT/STYLE //////////////
////////////////////////////////////////////////

function lcso_del_stored_script() {
	if(!isset($_POST['lcso_nonce']) || !wp_verify_nonce($_POST['lcso_nonce'], 'lcso_ajax')) {
        wp_die('Cheating?');
    }
	
    if(!isset($_POST['script_type']) || !in_array($_POST['script_type'], array('css', 'js'))) {
        wp_die(__('Missing or wrong script type', 'lcso_ml'));
    }
    if(!isset($_POST['script_slug']) || empty($_POST['script_slug']) || !is_string($_POST['script_slug'])) {
        wp_die(__('Missing or wrong script name', 'lcso_ml'));
    }
    
    
    $script_slug = $_POST['script_slug'];
    $opt_name = ($_POST['script_type'] == 'css') ? 'lcso_queued_styles' : 'lcso_queued_scripts';
    
    if($script_slug == '||ALL||') {
        delete_option($opt_name);
    }
    else {
        $stored = (array)get_option($opt_name, array());
        if(!isset($stored[$script_slug])) {
            wp_die(__('Subject name not found among stored ones', 'lcso_ml'));   
        }

        unset($stored[$script_slug]);
        update_option($opt_name, $stored, false);
    }
    
    wp_die('success');
}
add_action('wp_ajax_lcso_del_stored_script', 'lcso_del_stored_script');