<?php 

// scripts filter subject
function lcso_scripts_filter_subj_cb($field_id, $field, $value, $all_vals) {
    ?>
    <table class="widefat fixed">
        <tbody>
            <tr>
                <td>
                    <button type="button" class="button button-primary lcso_scripts_filter_subj_btn" data-subj="js">JavaScript</button>
                    <button type="button" class="button button-secondary lcso_scripts_filter_subj_btn" data-subj="css">CSS</button>
                    
                    <button type="button" class="button button-secondary lcso_fetch_scripts">
                        <i class="dashicons dashicons-update"></i>
                        <span><?php esc_html_e('fetch again', 'lcso_ml') ?></span>
                    </button>
                </td>
            </tr> 	
        </tbody>
    </table>
    <p class="lcso_alignright">
        <small><i class="dashicons dashicons-info-outline"></i> <?php esc_html_e('scripts are dynamically fetched also navigating through website pages', 'lcso_ml') ?></small>
    </p>    
    <?php
}




// scripts filter
function lcso_scripts_filter_list_cb($field_id, $field, $value, $all_vals) {
    $data = array(
        'js' => get_option('lcso_queued_scripts', array()),
        'css'=> get_option('lcso_queued_styles', array()),
    );
    
    foreach($data as $subj => $subj_data) {
        $visibility = ($subj == 'css') ? 'lcso_displaynone' : '';
        
        echo '
        <div class="lcso_scripts_filter_list_wrap '. $visibility .'" data-subj="'. $subj .'">';
        
        
        if(empty($subj_data)) {
            echo '
            <br/><br/>
            <h3 class="lcso_aligncenter">
                <em>.. '. esc_html__('no scripts fetched yet', 'lcso_ml') .' ..</em>
            </h3>';
        }
        else {
            $ignored = get_option('lcso_'. $subj .'_ignore', array());
            $filtered = get_option('lcso_'. $subj .'_filter', array());
             
            echo '
            <table class="widefat fixed striped">
                <thead>
                    <tr>
                        <th>
                            <strong>'. esc_html__('Script', 'lcso_ml') .'</strong>
                            <input type="text" value="" placeholder="🔎 '. esc_html__('search', 'lcso_ml') .'" class="lcso_search_script" />
                            <i class="dashicons dashicons-no-alt lcso_clear_script_search lcso_displaynone" title="'. esc_html__('clean search', 'lcso_ml') .'"></i>
                        </th>
                        <th title="'. esc_attr__("Check to exclude element from scripts concatenation", 'lcso_ml') .'"><strong>'. esc_html__('Do NOT concat?', 'lcso_ml') .'</strong></th>
                        <th>
                            <strong>'. esc_html__('Use only in these pages', 'lcso_ml') .' 
                            <small style="padding-left: 5px;">('. esc_html__('use URLs - one per row - supports regex', 'lcso_ml') .')</small></strong>
                        </th>
                        <th style="width: 30px;">
                            <i class="lcso_del_script dashicons dashicons-trash" data-script-slug="||ALL||" title="'. esc_attr__('empty the list', 'lcso_ml') .'"></i>
                        </th>
                    </tr>
                </thead>
                <tbody>';
            
            
                // sort by name
                $sorted = array();
                foreach($subj_data as $script_name => $script_data) {
                    $src_to_show = esc_html($script_data->src);
                    if(strpos($src_to_show, 'wp-content') !== false) {
                        $src_to_show = explode('wp-content', $script_data->src);
                        $src_to_show = '..'. end($src_to_show);
                    }
                    
                    $sorted[$script_name] = $src_to_show;
                }
                asort($sorted, SORT_NATURAL);
            
            
            
                // group by subject
                $grouped = array();
                foreach($sorted as $script_name => $src_to_show) {
                    if(substr($src_to_show, 0, 4) == 'http') {
                        continue;   
                    }
                    $orig_src_to_show = $src_to_show;
                    
                    if(substr($src_to_show, 0, 3) == '../') {
                        $src_to_show = substr($src_to_show, 3);   
                    }
                    $arr = explode('/', $src_to_show);
                    
                    
                    $group = $orig_src_to_show;
                    if($arr[0] == 'plugins' || $arr[0] == 'themes') {
                        $group = $arr[0] .'/'. $arr[1];   
                    }
                    
                    if(!isset($grouped[$group])) {
                        $grouped[$group] = array();  
                    }
                    $grouped[$group][$script_name] = $orig_src_to_show;
                }
                
            
                // show as grouped only if there are two of the same origin
                $final_grouped = array(
                    'ungrouped' => array()
                );
                foreach($grouped as $group_name => $scripts) {
                    if(count($scripts) > 1) {
                        $final_grouped[$group_name] = $scripts;   
                    } else {
                        $final_grouped['ungrouped'] = array_merge($final_grouped['ungrouped'], $scripts); 
                    }
                }
                
                // be sure ungrouped is last
                $ugpd = $final_grouped['ungrouped'];
                unset($final_grouped['ungrouped']);
                $final_grouped['ungrouped'] = $ugpd;
            
            
                foreach($final_grouped as $group_name => $scripts) {      
                    $orig_group_name = $group_name;
                    
                    if($group_name == 'ungrouped') {
                        $group_name = '('. esc_html__('ungrouped', 'lcso_ml') .')';
                    }
            
                    echo '
                    <tr class="lcso_scripts_group">
                        <td colspan="4"><i class="dashicons dashicons-arrow-right-alt2"></i> '. $group_name .'</td>
                    </tr>';
                    
                    
                    foreach($scripts as $script_name => $src_to_show) {
                        
                        // SPECIAL CASE - if there's elementor or $ must be left untouched due to their damn coding flow
                        if($subj == 'js' && is_plugin_active('elementor/elementor.php') && ($script_name == '$' || strpos($script_name, 'elementor') !== false)) {
                          continue;
                        }

                        if($orig_group_name != 'ungrouped') {
                            $src_to_show = str_replace($orig_group_name .'/', '<span class="lcso_displaynone">'. $orig_group_name .'/</span>', $src_to_show);   
                        }
                        
                        $no_concat = (is_array($ignored) && in_array($script_name, $ignored)) ? 'checked="checked"' : '';
                        $only_in_pages = (isset($filtered[$script_name])) ? $filtered[$script_name] : '';

                        echo '
                        <tr>
                            <td>
                                <strong>'. esc_html($script_name) .'</strong><br/>
                                <small>'. $src_to_show .'</small>
                            </td>
                            <td>
                                <input type="checkbox" name="lcso_'. $subj .'_ignore[]" value="'. esc_attr($script_name) .'" '. $no_concat .' class="lcwp_sf_check" autocomplete="off" />
                            </td>
                            <td>
                                <textarea name="lcso_'. $subj .'_filter['. esc_attr($script_name) .']" onkeyup="window.lcwp_sf_textAreaAdjust(this);" autocomplete="off">'. esc_textarea($only_in_pages) .'</textarea>
                            </td>
                            <td>
                                <i class="lcso_del_script dashicons dashicons-trash" data-script-slug="'. esc_attr($script_name) .'" title="'. esc_attr__('remove from the list', 'lcso_ml') .'"></i>
                            </td>
                        </tr>';
                    }
                }
            
                echo '        
                </tbody>
            </table>';
        }
        
        
        echo '
        </div>';
    }
    
    ?>
    <script type="text/javascript">
    (function($) { 
        "use strict";        
        
        // autoheight textarea on open
        $(document).ready(function($) {
            autoSize_textarea();
        });
        addEventListener("hashchange", function() {
            autoSize_textarea();
        });
        $(document).on('click', '.lcso_scripts_filter_subj_btn', function() {
            autoSize_textarea();
        });
            
        const autoSize_textarea = function() {
            setTimeout(() => {
                $('.lcso_scripts_filter_list_wrap textarea, [name="lcso_ignored_js"], [name="lcso_ignored_css"]').trigger('keyup');
            }, 100);
        };
        
        
        
        
        // refetch scripts
        $(document).on('click', '.lcso_fetch_scripts', function() {
            if(window.lcso_is_acting) {
                return false;
            }

            window.lcso_is_acting = true;
            const $subj = $(this);
            $subj.css('cursor', 'progress').prop('disabled', 'disabled');

            
            let data = {
                action      : 'lcso_store_queued_scripts',
                lcso_nonce  : window.lcso_nonce
            };
            $.post(ajaxurl, data, function(response) {
                if(response.trim() == 'success') {
                    lc_wp_popup_message('success', `<?php esc_html_e('Scripts successfully re-fetched!', 'lcso_ml') ?>`); 
                    
                    setTimeout(() => {
                        location.reload();
                    }, 1000);
                }
                else {
                    lc_wp_popup_message('error', response);	
                }
            })
            .fail(function(e) {
                if(e.status) {
                    console.error(e);
                    lc_wp_popup_message('error', `<?php esc_html_e('Error performing the operation', 'lcso_ml') ?>`);
                }
            })
            .always(function() {
                $subj.css('cursor', 'default').removeAttr('disabled');
                window.lcso_is_acting = false;
            });
        });
        
        
        
        
        // remove script from the list
        $(document).on('click', '.lcso_del_script', function() {
            const script_slug = $(this).data('script-slug'),
                  script_type = ($(this).parents('.lcso_scripts_filter_list_wrap').data('subj') == 'js') ? 'js' : 'css',
                  $tr = $(this).parents('tr').first();
            
            const warn = (script_slug == '||ALL||') ? 
                `<?php echo esc_html_e('Do you really want to empty the whole scripts list?', 'lcso_ml') ?>` : 
                `<?php echo esc_html_e('Do you really want to remove this script from the list? If it will be found again on frontend, it will be re-added', 'lcso_ml') ?>`;
            
            if(window.lcso_is_acting || !confirm(warn)) {
                return false;   
            }
            
            window.lcso_is_acting = true;
            $tr.css('pointer-events', 'none').css('opacity', 0.5);

            let data = {
                action      : 'lcso_del_stored_script',
                script_slug : script_slug,
                script_type : script_type,
                lcso_nonce  : window.lcso_nonce,
            };
            $.post(ajaxurl, data, function(response) {
                if(response.trim() == 'success') {
                    if(script_slug == '||ALL||') {
                        lc_wp_popup_message('success', `<?php esc_html_e('Scripts list successfully emptied!', 'lcso_ml') ?>`); 
                    
                        setTimeout(() => {
                            location.reload();
                        }, 1000);
                    }
                    else {
                        $tr.remove();
                    }
                } 
                else {
                    lc_wp_popup_message('error', response);
                    $tr.removeAttr('style');
                }
            })
            .fail(function(e) {
                if(e.status) {
                    console.error(e);
                    lc_wp_popup_message('error', `<?php esc_html_e('Error performing the operation', 'lcso_ml') ?>`);
                }

                $tr.removeAttr('style');
            })
            .always(function() {
                window.lcso_is_acting = false;
            });
        });
        
        
        
        
        // subject switch
        $(document).on('click', '.lcso_scripts_filter_subj_btn:not(.button-primary)', function() {
            const subj = $(this).data('subj');
            
            $('.lcso_scripts_filter_subj_btn').removeClass('button-primary').addClass('button-secondary');
            $(this).addClass('button-primary').removeClass('button-secondary');
            
            $('.lcso_scripts_filter_list_wrap').addClass('lcso_displaynone');
            $('.lcso_scripts_filter_list_wrap[data-subj="'+ subj +'"]').removeClass('lcso_displaynone');
        });
        
        
        
        
        // scripts search
        let scripts_search_tout;
        $(document).on('keydown input', '.lcso_search_script', function(e) {
            if (e.keyCode == 13 || e.keyCode == 32) {
                e.preventDefault();
                return false;
            }
            
            const val = $(this).val().trim(),
                  $table = $(this).parents('table').first();
            
            // no spaces
            const escaped_val = val.replaceAll(' ', '').toLowerCase();
            if(escaped_val.length != val.length) {
                $(this).val(escaped_val);
            }
            
            if(scripts_search_tout) {
                clearTimeout(scripts_search_tout);
            }
            scripts_search_tout = setTimeout(() => {
                const val = $(this).val().trim();
                
                if(val.length < 3) {
                    $table.find('tbody tr').removeClass('lcso_displaynone');
                    $table.find('.lcso_clear_script_search').addClass('lcso_displaynone');
                    return true;
                }
                
                
                $table.find('tbody tr').each(function() {
                    const $tr = $(this),
                          to_match = $tr.find('td').first().text();
                    
                    if(to_match.indexOf(escaped_val) !== -1) {
                        $tr.removeClass('lcso_displaynone');
                    } else {
                        $tr.addClass('lcso_displaynone');    
                    }
                });
                
                $table.find('.lcso_clear_script_search').removeClass('lcso_displaynone');
            }, 400);
        });
        

        // clear search
        $(document).on('click', '.lcso_clear_script_search', function() {
            $(this).parent().find('input').val('').trigger('input'); 
        });
        
        
        
        
        
    })(jQuery);
    </script>
    <?php
}






// donate if like
function lcso_donate_if_like_cb($field_id, $field, $value, $all_vals) {
    ?>
    <table id="lcso_donate_if_like_wrap" class="widefat">
        <tbody>
            <tr>
                <td>
                    <img src="<?php echo LCSO_URL ?>/img/lc_stroke.png" alt="lc stroke" />
                    <h3><?php esc_html_e('Are you enjoying the plugin?', 'lcso_ml') ?></h3>
                    <p><?php echo sprintf(
                        esc_html__('This is a %sfree tool%s brought you by %sLCweb%s!', 'lcso_ml'),
                        '<strong>',
                        '</strong>',
                        '<strong><a href="https://lcweb.it" target="_blank">',
                        '</a></strong>'
                    ) ?><br/><?php echo esc_html__('To maintain a project through the years requires time and expertise', 'lcso_ml') .'.</p><p>'. esc_html__('If the plugin helped your business, is always kind to show some appreciation.', 'lcso_ml') ?></p>
                    
                    <a href="https://lcweb.it/donations/" target="_blank" class="button-secondary">
                        <i class="dashicons dashicons-thumbs-up"></i>
                        <span><?php esc_html_e('Make a donation', 'lcso_ml') ?></span>
                    </a>
                </td>
            </tr> 	
        </tbody>
    </table>
<?php
}
