<?php 
include_once(LCSO_DIR .'/classes/simple_form_validator.php');
include_once(LCSO_DIR .'/settings/settings_engine.php'); 
include_once(LCSO_DIR .'/settings/custom_fields.php');
include_once(LCSO_DIR .'/settings/structure.php'); 


global $pc_wp_user;
$ml_key = 'lcso_ml'; // requierd for mandatory_js.php

lcwp_settings_engine::$prod_acronym = 'lcso';
lcwp_settings_engine::$css_prefix = 'lcso_';
lcwp_settings_engine::$ml_key = 'lcso_ml';

$engine = new lcwp_settings_engine('lcso_settings', $GLOBALS['lcso_settings_tabs'], $GLOBALS['lcso_settings_structure']);
?>

<div class="wrap lcwp_settings_wrap">
    <div class="lcwp_settings_head">
        <h2 class="lcwp_settings_page_title"><?php esc_html_e('LC Scripts Optimizer Settings', 'lcso_ml') ?></h2>  
        
        <div class="lcwp_settings_head_cmds">
            <?php echo $engine->import_export_btns() ?>
            <form class="lcwp_sf_search_wrap">
                <i class="dashicons dashicons-no-alt"></i>
                <input type="text" name="lcwp_sf_search" value="" placeholder="<?php esc_attr_e('search fields', 'lcso_ml') ?> .." /> 
            </form>
        </div>
    </div>

	<?php
    // get fetched data and allow customizations
    if($engine->form_submitted()) {
        $fdata = $engine->form_data;
        $errors = (!empty($engine->errors)) ? $engine->errors : array();
        
        
        
        /////////////////////////////////////////////////////////
        
        
        // be absolutely sure scripts filters have the script slug as key (TODO - remove when all plugins will have Simple Form Validator v1.1.1 .. in a far future!)
        foreach(array('js', 'css') as $subj) {
            if(
                !isset($fdata['lcso_'. $subj .'_filter']) || 
                empty($fdata['lcso_'. $subj .'_filter']) || 
                !is_array($fdata['lcso_'. $subj .'_filter']) || 
                !isset($fdata['lcso_'. $subj .'_filter'][0])
            ) {
                continue;   
            }
            
            $fdata['lcso_'. $subj .'_filter'] = array();
            foreach($_POST['lcso_'. $subj .'_filter'] as $arr_key => $arr_val) {
                $fdata['lcso_'. $subj .'_filter'][$arr_key] = $arr_val;
            }
        }
        
        
        /////////////////////////////////////////////////////////
        
    
        
        // LCSO-FILTER - manipulate setting errors - passes errors array and form values - error subject as index + error text as val
        $errors = apply_filters('lcso_setting_errors', $errors, $fdata);	
        
        
        // save or print error
        if(empty($errors)) {
            
            // strip empty filters
            foreach(array('js', 'css') as $subj) {
                if(!isset($fdata['lcso_'. $subj .'_filter']) || !is_array($fdata['lcso_'. $subj .'_filter'])) {
                    continue;   
                }
                
                foreach($fdata['lcso_'. $subj .'_filter'] as $key => $val) {
                    if(empty($val)) {
                        unset($fdata['lcso_'. $subj .'_filter'][$key]);   
                    }
                }
            }
            
            
            
            // PC-FILTER - allow data manipulation (or custom actions) before settings save - passes form values
            $engine->form_data = apply_filters('lcso_before_save_settings', $fdata); 
            
            // save
            $engine->save_data();
            $engine->successful_save_redirect();
        }
        
        // compose and return errors
        else {
            echo $engine->get_error_message_html($errors);	
        }
    }
	
	
	// if successfully saved
	echo $engine->get_success_message_html();
	
	// print form code
    echo $engine->get_code();
    ?>
</div>




<?php // SCRIPTS ?>
<script type="text/javascript">
(function($) { 
    "use strict";     
    
    window.lcso_nonce = '<?php echo wp_create_nonce('lcso_ajax') ?>';
    window.window.lcso_is_acting = false;
    
    
    $(document).ready(function($) {
        
        // unwrap unwanted warnings in lcwp_settings_head
        setTimeout(function() {
            $('.lcwp_settings_head > *').not('.lcwp_settings_page_title, .lcwp_settings_head_cmds').each(function() {
                $('.lcwp_settings_wrap').prepend( $(this).detach() ); 
            });
        }, 200);
        
        
        
        
        // clean scripts cache
        $(document).on('click', '.lcso_clean_cache', function() {
            if(window.lcso_is_acting || !confirm(`<?php esc_attr_e('Deleting cache files your server will need to recreate them from scratch. Continue?', 'lcso_ml') ?>`)) {
                return false;   
            }

            window.lcso_is_acting = true;
            
            const $subj = $(this);
            $subj.css('cursor', 'progress').prop('disabled', 'disabled');

            let data = {
                action: 'lcso_empty_scripts_cache',
                lcso_nonce: window.lcso_nonce
            };
            $.post(ajaxurl, data, function(response) {
                if(response.trim() == 'success') {
                    lc_wp_popup_message('success', `<?php esc_attr_e('Cache successfully cleaned!', 'lcso_ml') ?>`);	

                    setTimeout(function() {
                        location.reload();    
                    }, 1000);
                } 
                else {
                    lc_wp_popup_message('error', response);	
                }
            })
            .fail(function(e) {
                if(e.status) {
                    console.error(e);
                    lc_wp_popup_message('error', `<?php esc_html_e('Error performing the operation', 'lcso_ml') ?>`);
                }
            })
            .always(function() {
                $subj.css('cursor', 'default').removeAttr('disabled');
                window.lcso_is_acting = false;
            });
        });		
    });
    
    
    <?php require_once('mandatory_js.php'); ?>
})(jQuery);   
</script>


<?php
// LCSO-ACTION - allow extra code printing in settings (for javascript/css)
do_action('lcso_settings_extra_code');
?>
